Bug 16572

Summary: Accessibility improvements request
Product: R Reporter: chris.spadijer
Component: Windows GUI / Window specificAssignee: R-core <R-core>
Status: CLOSED WONTFIX    
Severity: enhancement CC: chris.spadijer, murdoch
Priority: P5    
Version: R 3.2.2   
Hardware: x86_64/x64/amd64 (64-bit)   
OS: Windows 64-bit   
Attachments: Review of R's accessibility strengths/weaknesses
Review of R's accessibility strengths/weaknesses
Review of R's accessibility strengths/weaknesses 1.3

Description chris.spadijer 2015-10-19 13:45:05 UTC
Created attachment 1927 [details]
Review of R's accessibility strengths/weaknesses

Good morning.
There have been numerous requests by employees within the federal department I work for to have R.  In order for R to be used within our department it has to pass the following:
A security assessment
An accessibility assessment
A bilingual assessment (English and French)

The results of the accessibility assessment have been shared with me. I would like to pass on the report to you for possible review in order to improve R.

Please see the attached document the breaks down what was reviewed in R and how well it did in different areas.

Any questions please email me and I can have the accessibility team get in contact with you.

Thanks

Chris
Comment 1 Duncan Murdoch 2015-10-19 14:53:13 UTC
We are interested in making R accessible, however the posted document is incomplete.  Appendix A, the list of defiencies, is empty.
Comment 2 chris.spadijer 2015-10-22 20:18:40 UTC
Created attachment 1928 [details]
Review of R's accessibility strengths/weaknesses
Comment 3 chris.spadijer 2015-10-22 20:21:08 UTC
Hi,
I contacted the group that created the accessibility report.  They have updated it and sent it back to me.  See last post, it contains the most recent copy.

Thanks

Chris
Comment 4 Duncan Murdoch 2015-10-23 17:52:41 UTC
Thanks for getting the details, but there's not much detail in them:

K.1 answers the question incorrectly.  The question was about keyboard equivalents, not keyboard shortcuts, which are the next question.  R does have keyboard equivalents for saving and loading workspaces:  "save.image()" and "load()".

K.11, CG.1, CG.2, OE.1, ST.3, ST.4, I.5, I.6, PE.1, D.1 and D.3 are all empty explanations, adding no information beyond the questionaire answer.  Some of
them may be correct.  I'm pretty sure some of them are not.

CO.1 is just false.  The user already knows what is user input because they typed it; the colour is an enhancement.

CO.4 and CO.5 are also false.  You can load your own colour scheme.

OE.3 is false.  You can install your own error handlers.

That leaves K.8 (shortcuts Ctrl-S and Ctrl-P) and CO.3 (allow any colour), and maybe some of the "empty" ones.   I'd say CO.3 is quite low priority (we allow more than 600 colours, but not the full "32 bit" set).  I'll add the control key shortcuts, because that's very easy.
Comment 5 Duncan Murdoch 2015-10-23 19:46:34 UTC
K.8 is fixed as of r69562 in R-patched and R-devel.
Comment 6 chris.spadijer 2015-11-03 22:06:48 UTC
Created attachment 1930 [details]
Review of R's accessibility strengths/weaknesses 1.3

Hi Duncan.

Much appreciated.  Thanks for resolving K8.
I shared your last comments with the accessibility team and they further refined the document with more details.
They have agreed to join this site if you have any further concerns about their document and will respond to you directly.

Note: I have had a different team review the tool in French.  I will submit that review as a separate bug.

Thanks
Comment 7 Duncan Murdoch 2015-11-04 01:12:03 UTC
I've looked through the list, and all of the "problems" do not look as though they are worth the time to fix.  (Complaining about the lack of colons in a dialog box?  Come on.)

If you are interested in committing resources to fix these things, you have two choices:

 - You can make the changes locally, and build R yourself with them.  That's the easiest approach in the short term, but will be hard to maintain in the long term.

 - You can submit patches to us, and if they are acceptable, we will incorporate them.  Please start small; we won't necessarily accept your patches, and it's less likely if they take too much time to review.

You can contact me offline if you want to discuss these choices.